//+------------------------------------------------------------------+
//|                                                                  |
//|                                                       Antisyzygy |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Antisyzygy"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_width1 2
#property indicator_width2 2

//---- Indicator Parameters
extern int     PriceMode                  = 0;     //Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int     MAPeriod                   = 15;  //Period for MA
extern int     MAMode                     = 1;  //MA Mode: 0-SMA,1-EMA,2-SMMA,3-LWMA

//---- Indicator Buffers
double     Diff[];
double     Diff2[];
double     MA[];

int        draw_begin, timeframe;
string     symbol;


int init()
{

  symbol=Symbol();
  timeframe=Period();
   
//---- Indicator buffers mapping
   IndicatorBuffers(3);
   SetIndexBuffer(0,Diff);
   SetIndexBuffer(1,Diff2);
   SetIndexBuffer(2,MA);
//---- Drawing setting
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   draw_begin = MAPeriod;              //Calculate the beginning of the drawing area
   SetIndexDrawBegin(0,draw_begin);      
   SetIndexDrawBegin(1,draw_begin);                
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);

//---- Name for DataWindow and Indicator subwindow label
   IndicatorShortName("Differential");
   SetIndexLabel(0,"First Derivative");
   SetIndexLabel(1,"Second Derivative");

//---- Initialization done
   return(0);
}


int start()
{
   int limit, i, shift;
   int counted_bars=IndicatorCounted();
   
   if(counted_bars<1)
   for(i=1;i<=draw_begin;i++) 
   {
      Diff[Bars-i]=0; 
      Diff2[Bars-i]=0;
      MA[Bars-i]=0;
   }

//---- Last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

//---- Limit for the 
   limit=Bars-counted_bars;
 
   for(shift=limit; shift>=0; shift--)
   {
      MA[shift]=iMA(symbol,timeframe,MAPeriod,0,MAMode,PriceMode,shift);
   }
   
   for(shift=limit; shift>=0; shift--)
   {
      if(shift!=0)
      {
         Diff[shift]=(MA[shift-1]-MA[shift+1])/2;
         Diff2[shift]=(MA[shift-1]-2*MA[shift]+MA[shift+1]);
      }
      else
      {
         Diff[shift]=(3*MA[shift]-4*MA[shift+1]+MA[shift+2])/2;
         Diff2[shift]=(3*Diff[shift]-4*Diff[shift+1]+Diff[shift+2])/2;
      }
   }
  
//---- done
   return(0);

}